Subject: includes and stuff
From: Wouter van Oortmerssen <[email-masked]>
To: [email-masked]
Date: Tue, 27 Jul 1993 18:26:25 +0200

>> Salve, amici!
>> 
>> [xpk stuff deleted]
>> I'm not 100% sure the xpkmaster.m module is exactly the way it should be. 
>> Running Showmodule through it, it came up the way I expected, but I should
>> warn you that I did NOT use the standard 'p2m' program to create the
 
I checked the file format, but that seems to be OK (of course I don't
know if that also holds for the actual registers etc.).
 
>> module, as I don't have c include files, and I didn't feel like using
>> harddrive space on maintaining C include files when I very much prefer
>> working in E.
 
You only need the xpk_whatever_pragmas.h file, which you can delete after
you've succesfully completed the conversion. No space wasted, I'd say.
 
>> In any event, I'm pretty sure the xpkmaster.m module will work as
>> expected.  I simply examined the pragmas and wrote the binary module file
>> by hand using a sector editor.  I figured out Wouter's system for handling
 
Oh my what a work. didn't the xpk distribution have a pragmas file?
 
>> that kind of module work by comparing Showmodule's output of a module to 
>> that module's hex values.. pretty simple, really.  But, there's always the
>> chance that I screwed up somehow, so I thought I'd point this out.
>>
>> [more xpk]
>>
>> I'd like to request, however, that someone write a program to convert a
>> fairly standard text file to a binary module file for use by E.  The
>> current method of needing C or ASM include files to do something that
>> could easily be handled by examining the source code and re-writing it
>> to another program's syntax is inelegant, in my humble opinion.  In any
>> event, it slowed me down <grin>.
 
well, the reason for this is simply that those libraries usually
come with C/Asm includes anyway, and it's the fastest way to get
a .m file. It will take some time before all libraries come with
E modules.
 
>> That is to say, it'd be nice to have a program to take a text file that
>> had such syntax as:
>>
>> [syntax examples deleted] 
>> 
>> and so on, and convert it into binary .m files that E could use.  I've
>> found that most of these include files are not that difficult to
>> understand, and could be re-written as some other 'standard' that could be
>> converted to a binary.  
 
Well, for CONST and OBJECT definitions, with the coming v2.5 EC you can
just write them in E syntax, and use EC to produce a .m file.
For library definitions the .fd syntax might be nicer than pragmas
(they're more readable and quite language independant). I could probably
write an fd2module program. For now, some may have the fd2pragma program
that can be used to get from fd to module (Son le? :-).
 
>> In any event, if and when I FINALLY finish my own program, and I have
>> enough time to work on this, I might consider trying to create such a
>> utility.. but I really don't anticipate having the time to handle it.  If
>> someone else out there is willing to work on such a project, there is at
>> least one user out here who would be grateful.
 
Wouter
 
   ____  Wouter van Oortmerssen, [email-masked]
  / __/  "Einen Satz verstehen, heisst, wissen was der Fall ist,
 / __/    wenn er wahr ist" - Wittgenstein
/___/  ->subscribe to the E mailing list: [email-masked]<-